var gadget = System.Gadget.document.parentWindow;

var backgroundFilesCount = 0;

function SetSliderPosition(slider, sliderDisplay, value)
{
    var sliderPosition = Math.round(slider.distance * ( (sliderDisplay.value - sliderDisplay.from) / sliderDisplay.valuecount ));
    slider.style.left = sliderPosition + "px";
}

function OnPrivacyModeLabelClick()
{
    privacyModeCheckBox.checked = !privacyModeCheckBox.checked;
}

function OnClearOnShutdownLabelClick()
{
    clearOnShutdownCheckBox.checked = !clearOnShutdownCheckBox.checked;
}

function InitSettings()
{
    // read settings if present
    if (System.Gadget.Settings.read("settingsSaved"))
    {
		backgroundFilesCount = System.Gadget.Settings.read("backgroundFilesCount");

		backgroundImageIndex = System.Gadget.Settings.read("backgroundImageIndex");
		if (backgroundImageIndex != "")
		{ 
			PreviewBackgroundImage();
		}

		var historyCapacity = System.Gadget.Settings.read("historyCapacity");
		if (historyCapacity != "")
		{ 
			historyCapacityDisplay.value = historyCapacity;
			SetSliderPosition(historyCapacitySlider, historyCapacityDisplay, historyCapacity);
		}

		var charsPerItem = System.Gadget.Settings.read("charsPerItem");
		if (charsPerItem != "")
		{ 
			maxItemCharsDisplay.value = charsPerItem;
			SetSliderPosition(maxItemCharsSlider, maxItemCharsDisplay, charsPerItem);
		}

		var fontSize = System.Gadget.Settings.read("fontSize");
		if (fontSize != "")
		{
			fontSizeDisplay.value = fontSize;
			SetSliderPosition(fontSizeSlider, fontSizeDisplay, fontSize);
		}

		var fontColor = System.Gadget.Settings.readString("fontColor");
		if (fontColor == 0)
		    fontColor = "000000";
		if (fontColor != "")
		{
			fontColorInput.innerText = fontColor;
		}
		
		var privacyMode = System.Gadget.Settings.read("privacyMode");
		privacyModeCheckBox.checked = privacyMode;

		var clearOnShutdown = System.Gadget.Settings.read("clearOnShutdown");
		clearOnShutdownCheckBox.checked = clearOnShutdown;
	}
}

System.Gadget.onSettingsClosing = SettingsClosing;
function SettingsClosing(event)
{
	if (event == null || event.closeAction == event.Action.commit) // save just chosen settings
	{
		System.Gadget.Settings.write("settingsSaved", true);
		System.Gadget.Settings.write("backgroundImageIndex", backgroundImageIndex);
        System.Gadget.Settings.write("historyCapacity", historyCapacityDisplay.value);
		System.Gadget.Settings.write("charsPerItem", maxItemCharsDisplay.value);
		System.Gadget.Settings.write("fontSize", fontSizeDisplay.value);
		System.Gadget.Settings.writeString("fontColor", fontColorInput.value);
		System.Gadget.Settings.write("privacyMode", privacyModeCheckBox.checked);
		System.Gadget.Settings.write("clearOnShutdown", clearOnShutdownCheckBox.checked);
		
		// Set sliders
		SetSliderPosition(historyCapacitySlider, historyCapacityDisplay, historyCapacityDisplay.value);
		SetSliderPosition(maxItemCharsSlider, maxItemCharsDisplay, maxItemCharsDisplay.value);
		SetSliderPosition(fontSizeSlider, fontSizeDisplay, fontSizeDisplay.value);
	}
	
	if (event == null)
	    gadget.LoadSettings();
	else
	    event.cancel = false;
}

function SettingsApply()
{
    SettingsClosing();
}

function SettingsOK()
{
    SettingsClosing();
    hideFlyout();
}

function PreviewBackgroundImage()
{
    backgroundImagePreview.src = "backgrounds/" + backgroundImageIndex + ".png";
}

function PreviewBackgroundImageForward()
{
    backgroundImageIndex++;
    if (backgroundImageIndex > backgroundFilesCount)
    {
        backgroundImageIndex = 1;
    }
    PreviewBackgroundImage();
}

function PreviewBackgroundImageBack()
{
	backgroundImageIndex--;
	if (backgroundImageIndex < 1)
	{
	    backgroundImageIndex = backgroundFilesCount;
	}
    PreviewBackgroundImage();
}

function SettingsUpdateImage(img, state)
{
    img.src = "images/" + "settings_" + img.src.split("_")[1] + "_" + state + ".png";
}

function BrowseBackgrounds()
{
    path = gadget.ax.SelectBackground();
    if (path != "")
        ChangeBackgroundInput(path);
}

function ParseBackgroundIndexFromFilePath(backgroundFilePath)
{
    var fileName = backgroundFilePath;
    var last = backgroundFilePath.lastIndexOf("\\")
    var ext = backgroundFilePath.lastIndexOf(".png")
    if (last > 0 && ext > 0 && ext - last > 0)
    {
        var imageIndex = -1;
        try
        {
            var imageIndexString = backgroundFilePath.substring(last + 1, ext);
            imageIndex = parseInt(imageIndexString);
        }
        catch (ext)
        { }

        if (imageIndex != -1)
            return parseInt(imageIndex);
        else
            return
    }
}

function ChangeBackgroundInput(backgroundFilePath)
{
    backgroundImageIndex = ParseBackgroundIndexFromFilePath(backgroundFilePath);
    PreviewBackgroundImage();
}